// 
//    libsocketcpp - a C++ class/library to allow easy TCP and UDP functionatliy
//    Copyright (C) 2001 Garrett Grice
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//    see the file "AUTHORS" for contact information.
    

#include <config.h>

#ifdef HAVE_STRING_H
#include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netdb.h>
#include <sys/wait.h>

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif

#include <unistd.h>



#include <stdio.h>
#include <stdlib.h>
#include "tcpsocket.h"

TCPSocket::TCPSocket() {
   newfd = 0;
}

TCPSocket::~TCPSocket() {
}

bool TCPSocket::Create() {
	sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if(sockfd==-1)
		return false;

	return true;

};


bool TCPSocket::Create(char nType) {
   if(nType == TCP)
      return Create();
   if(nType == UDP) {
      sockfd = socket(AF_INET, SOCK_DGRAM, 0);
      if(sockfd==-1)
	return false;
      
      return true;
   }
   return false;
}

bool TCPSocket::Connect(int nPort, char *Hostname) {
	hostent *Host;
	
	
	if((Host = gethostbyname(Hostname)) == NULL) {
		herror("gethosebyname");
		return false;
	}

	
	
	INetAddress.sin_family = AF_INET;
	INetAddress.sin_port = htons(nPort);
	INetAddress.sin_addr = *((struct in_addr *)Host->h_addr);
	bzero(&(INetAddress.sin_zero), 8);

	if(connect(sockfd, (struct sockaddr *)&INetAddress, sizeof(struct sockaddr)) == -1) {
		perror("connect");
		return false;
	}

	return true;
}

int TCPSocket::Send(const void *Message, int nLength) {
	int Bytes_Sent;
	
   if(newfd==0) 
     Bytes_Sent = send(sockfd, Message, nLength, 0);

   else
     Bytes_Sent = send(newfd, Message, nLength, 0);
   
   return Bytes_Sent;
}


int TCPSocket::Recv(void *Buffer, int nLength) {
	int Bytes_Recv;
   if(newfd==0)
     Bytes_Recv = recv(sockfd, Buffer, nLength, 0);

   else
     Bytes_Recv = recv(newfd, Buffer, nLength, 0);
   
   return Bytes_Recv;
}

bool TCPSocket::Close() {
	int Result;
	if(newfd==0)
	Result = close(sockfd);
    
	else
		Result = close(newfd);
	if(Result == -1) 
		return false;

	return true;
}

bool TCPSocket::InboundClose() {
   int Result;
   Result = close(newfd);
   
   if(Result == -1)
     return false;
   
   return true;
}

bool TCPSocket::Create(int nPort) {
   
    sockfd = socket(AF_INET, SOCK_STREAM, 0);  
           if(sockfd==-1)
                     return false;
   
   INetAddress.sin_family = AF_INET;
   INetAddress.sin_port = htons(nPort);
   INetAddress.sin_addr.s_addr = INADDR_ANY;
   bzero(&(INetAddress.sin_zero), 8);
   
   if(bind(sockfd, (struct sockaddr *)&INetAddress, sizeof(struct sockaddr)) == -1) {
      perror("bind");
      return false;
   }
      

   return true;
   
   
}

bool TCPSocket::Create(int nPort, char nType) {
  
	if(nType == TCP) {
	sockfd = socket(AF_INET, SOCK_STREAM, 0);  
           if(sockfd==-1)
                     return false;
	}
	if(nType == UDP) {
		sockfd = socket(AF_INET, SOCK_DGRAM, 0);
		if(sockfd==-1)
			return false;
	}

   INetAddress.sin_family = AF_INET;
   INetAddress.sin_port = htons(nPort);
   INetAddress.sin_addr.s_addr = INADDR_ANY;
   bzero(&(INetAddress.sin_zero), 8);
   
   if(bind(sockfd, (struct sockaddr *)&INetAddress, sizeof(struct sockaddr)) == -1) {
      perror("bind");
      return false;
   }
      

   return true;
   
}

bool TCPSocket::Listen() {
   
   if(listen(sockfd, 5) == -1) {
      perror("Listen");
      return false;
   }
   
   return true;
}

bool TCPSocket::Accept() {
   size_t sin_size = sizeof(struct sockaddr_in);
   //sockaddr_in RemoteAddress;
   if((newfd = accept(sockfd, (struct sockaddr *)&RemoteAddress, &sin_size)) == -1) {
      perror("accept");
      return false;
   }
   return true;
}

char *TCPSocket::GetRemoteIP() {
   return inet_ntoa(RemoteAddress.sin_addr);
}

   
   



